<?php

namespace Ulmus\Adapter;

use Ulmus\Common\PdoObject;
use Ulmus\Migration\FieldDefinition;

interface AdapterInterface {
    public const IDENTIFIER_FIELD = 1;
    public const IDENTIFIER_TABLE = 2;
    public const IDENTIFIER_DATABASE = 3;
    public const IDENTIFIER_SCHEMA = 4;
    public const IDENTIFIER_VALUE = 5;

    public function connect() : object /* | PdoObject|mixed */;
    public function buildDataSourceName() : string;
    public function setup(array $configuration) : void;
    public function escapeIdentifier(string $segment, int $type) : string;
    public function defaultEngine() : ? string;

    public function writableValue(/* mixed */ $value); /*: mixed*/
    
    
    /*   public function databaseName() : string;
    public function mapFieldType(FieldDefinition $field) : string;
    public function schemaTable(string $databaseName, string $tableName) /*: object|EntityCollection
*/
    public function repositoryClass() : string;
    public function queryBuilderClass() : string;
    public function tableSyntax() : array;
    public function whitelistAttributes(array &$parameters) : void;
    public function generateAlterColumn(FieldDefinition $definition, array $field) : string|\Stringable;
}
